Attribute VB_Name = "MainCode"
Option Explicit

Public Sub Main()
    Dim FileName As String
    FileName = LTrim$(RTrim$(Command$))
    If AZLeftGleich(FileName, Chr$(34)) Then
        FileName = Right$(FileName, Len(FileName) - 1)
    End If
    If AZRightGleich(FileName, Chr$(34)) Then
        FileName = Left$(FileName, Len(FileName) - 1)
    End If
    FileName = LTrim$(RTrim$(FileName))
    If FileName = "" Then
        MsgBox UCase$(App.EXEName) + " ""file""", , "Usage"
    Else
        CreateCueFile FileName
    End If
End Sub

Public Sub CreateCueFile(ByVal BinFileName As String)
    Dim FileName As String
    Dim F As Long
    F = InStrRev(BinFileName, ".")
    If Not AZRightGleich(UCase$(BinFileName), ".BIN") Then
        MsgBox "Es handelt sich nicht um eine BIN-Datei.", , "Fehler"
        Exit Sub
    End If
    FileName = Left$(BinFileName, Len(BinFileName) - 3) + "cue"
    
    Dim Temp As String
    Temp = "FILE """ + GetFileName(BinFileName) + """ BINARY" + vbCrLf + _
           "  TRACK 01 MODE1/2352" + vbCrLf + _
           "    INDEX 01 00:00:00" + vbCrLf
    
    IfExistThenDelete FileName
    Dim FileNum%
    FileNum% = FreeFile
    Open FileName For Binary Access Write As FileNum%
    Put #FileNum%, 1, Temp
    Close FileNum%
End Sub

Public Function AZLeft(Text As String, Lnge As Long, Optional NeueZeichen As String = " ") As String
    If Lnge > Len(Text) Then
        AZLeft = Text + String$(Lnge - Len(Text), NeueZeichen)
    Else
        AZLeft = Left$(Text, Lnge)
    End If
End Function

Public Function AZLeftGleich(MainText As String, CompareText As String) As Boolean
    AZLeftGleich = (AZLeft(MainText, Len(CompareText)) = CompareText)
End Function

Public Function AZRight(Text As String, Lnge As Long, Optional NeueZeichen As String = " ") As String
    If Lnge > Len(Text) Then
        AZRight = Text + String$(Lnge - Len(Text), NeueZeichen)
    Else
        AZRight = Right$(Text, Lnge)
    End If
End Function

Public Function AZRightGleich(MainText As String, CompareText As String) As Boolean
    AZRightGleich = (AZRight(MainText, Len(CompareText)) = CompareText)
End Function

Public Sub IfExistThenDelete(FileName As String)
    If Dir$(FileName) <> "" Then Kill FileName
End Sub

Public Function GetFileName(ByVal theFile As String) As String
    Dim X As Integer
    theFile = Replace(theFile, "/", "\")
    Do While Left$(theFile, 1) = "\"
        theFile = Right$(theFile, Len(theFile) - 1)
    Loop
    Do While Right$(theFile, 1) = "\"
        theFile = Left$(theFile, Len(theFile) - 1)
    Loop
    X = InStrRev(theFile, "\")
    If X <> 0 Then
        GetFileName = Right$(theFile, Len(theFile) - X)
    Else
        GetFileName = theFile
    End If
End Function
